<?php
class WatuPROCmonBridge {
   static function main() {
   	  global $wpdb;
   	  
   	  // save Campaign Monitor API key and client ID
   	  if(!empty($_POST['set_key']) and check_admin_referer('watuprocmon_settings')) {
			  $double_optin = empty($_POST['no_optin']) ? 0 : 1;   	  	
   	  	
   	  	  update_option('watuprocmon_api_key', $_POST['api_key']);
   	  	  update_option('watuprocmon_client_id', $_POST['client_id']);
   	  	  update_option('watuprochimp_no_optin', $double_optin);
   	  }
   	  $api_key = get_option('watuprocmon_api_key');
   	  $client_id = get_option('watuprocmon_client_id');
   	 
   	  // select exams
   	  $exams = $wpdb->get_results("SELECT * FROM ".WATUPRO_EXAMS." ORDER BY name");
   	  
   	  $auth = array('api_key' => $api_key);
			$wrap = new CS_REST_General($auth);
			
			//$result = $wrap->get_clients();
			// var_dump($result->response);
			   	  
   	  // add/edit/delete relation
   	  if(!empty($_POST['add']) and check_admin_referer('watuprocmon_rule')) {
				// no duplicates		
				$exists = $wpdb->get_var($wpdb->prepare("SELECT id FROM ".WATUPROCMON_RELATIONS."
					WHERE exam_id=%d AND list_id=%s AND grade_id=%d", $_POST['exam_id'], $_POST['list_id'], $_POST['grade_id']));   	  	
   	  	
   	  	if(!$exists) {
					$wpdb->query($wpdb->prepare("INSERT INTO ".WATUPROCMON_RELATIONS." SET 
						exam_id = %d, list_id=%s, grade_id=%d", $_POST['exam_id'], $_POST['list_id'], $_POST['grade_id']));
					}   	  
   	  }
   
   		if(!empty($_POST['save']) and check_admin_referer('watuprocmon_rule')) {
				$wpdb->query($wpdb->prepare("UPDATE ".WATUPROCMON_RELATIONS." SET 
					exam_id = %d, list_id=%s, grade_id=%d WHERE id=%d", 
					$_POST['exam_id'], $_POST['list_id'], $_POST['grade_id'], $_POST['id']));   	  
   	  }
   	  
			if(!empty($_POST['del']) and check_admin_referer('watuprocmon_rule')) {
				$wpdb->query($wpdb->prepare("DELETE FROM ".WATUPROCMON_RELATIONS." WHERE id=%d", $_POST['id']));
			}   	  
   	  
   	  // select existing relations
   	  $relations = $wpdb->get_results("SELECT * FROM ".WATUPROCMON_RELATIONS." ORDER BY id");
   	  
   	  // select all non-category grades and match them to exams and relations
   	  $grades = $wpdb->get_results("SELECT * FROM ".WATUPRO_GRADES." WHERE cat_id=0 ORDER BY gtitle");
   	  
   	  foreach($exams as $cnt=>$exam) {
   	  	  $exam_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $exam->ID) $exam_grades[] = $grade;
			  }
			  
			  $exams[$cnt]->grades = $exam_grades;
   	  }
   	  
   	  foreach($relations as $cnt=>$relation) {
   	  	  $rel_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $relation->exam_id) $rel_grades[] = $grade;
			  }
			  
			  $relations[$cnt]->grades = $rel_grades;
   	  }
   	     	  
   	  include(WATUPROCMON_PATH."/views/main.html.php");
   }

	 // actually subscribe the user
	 static function complete_exam($taking_id) {
	 	  global $wpdb;
	 	  
	 	 // echo "HERE BRIDGE 1";
	 	 $api_key = get_option('watuprocmon_api_key');
	 	 $auth = array('api_key' => $api_key);
			$wrap = new CS_REST_General($auth);
		 
	 	  // select taking		
	 	  $taking = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_TAKEN_EXAMS." 	
	 	  	WHERE ID=%d", $taking_id));
	 	  	
	 	  // if email not available, return false
			if(empty($taking->user_id) and empty($taking->email)) return false;
			
	 	  // see if there are any relations for this exam ID
	 	  $relations = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".WATUPROCMON_RELATIONS." 
		 	  WHERE exam_id=%d", $taking->exam_id));
		 	  
		 	if(!sizeof($relations)) return false;  
		 	 // echo "HERE BRIDGE 2";
	
			$email = $taking->email;
			$name = $taking->name;
			if(empty($email)) {
				$user = get_userdata($taking->user_id);
	      	$email = $user->user_email;
	      	$name = $user->display_name;
			}
			
			// name still empty? Default to guest although that's not a great idea
			if(empty($name)) $name = 'Guest';
	      
	      // add to MailChimp
	      $api_key = get_option('watuprocmon_api_key');
	   	   	
	   	$double_optin = (get_option('watuprocmon_no_optin') == '1') ? false : true;
	   	
	   	// select mailing lists from mailchimp
	   	foreach($relations as $relation) {
			  // check grade
			  if(!empty($relation->grade_id) and $relation->grade_id != $taking->grade_id) continue;
			 
			  	$_subcriber = new CS_REST_Subscribers($relation->list_id,  array('api_key' => $api_key));
		
			  	$sub = array('EmailAddress' => $email, 'Name' => $name);
			  	$response = $_subcriber->add($sub);
			  	// print_r($response);
				
			} // end foreach relation	
   } // end complete exam
}