<div class="wrap">
	<h1><?php _e('WatuPRO to Campaign Monitor Bridge', 'watuprocmon')?></h1>
	
	<p><?php _e('This bridge lets you automatically subscribe users who take your exams into select list in Campaign Monitor. You need to know your Campaign Monitor API key.', 'watuprocmon')?></p>
	
	<p><?php _e('Note that in order to have quiz taker subscribed you need their email address. So this will work the user is logged or (for non-logged in users) when you have selected "Send email to the user with their results" in the exam settings page.','watuprocmon')?> </p>
	
	<form method="post">
		<p>Your Campaign Monitor API Key: <input type="text" name="api_key" value="<?php echo $api_key?>" size="60"> <br />
		<?php _e('Your Campaign Monitor Client ID:', 'watuprocmon');?> <input type="text" size="60" name="client_id" value="<?php echo $client_id?>">
		<br>
		<input type="submit" name="set_key" value="<?php _e('Save Settings', 'watuprocmon');?>"</p>
		<?php wp_nonce_field('watuprocmon_settings');?>
	</form> 
	
	<?php if(empty($api_key)):?>
		<p><b><?php _e('You will not be able to add any rules until you enter your Campaign Monitor API Key and Client ID.', 'watuprocmon');?></b></p>
	<?php return;
	endif;
	if(!empty($result->error) or empty($result->total)):?>
		<p><?php _e("We couldn't retrieve any mailing lists from your Campaign Monitor account.", 'watuprocmon');?></p>
		<?php if(!empty($result->error)):?>
			<p><?php _e("We got this error from MailChimp:", 'watuprocmon');?> <b><?php echo $result->error;?></b></p>
		<?php endif;?>
		<p><a href="#" onclick="jQuery('#CmonResponse').toggle();return false;"><?php _e('Raw Campaign Monitor response (debug)', 'watuprocmon');?></a></p>
		<div style="display:none;" id="CmonResponse"><?php echo $json_result;?></div>
	<?php endif;?>
   
   <h2><?php _e('Add New Rule', 'watuprocmon')?></h2>	  
	  
	 <form method="post">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watuprocmon')?> <select name="exam_id" onchange="wcChangeQuiz(this.value, 'wbbGradeSelector');">
	 			<option value=""><?php _e('- Select quiz -', 'watuprocmon');?></option>
	 			<?php foreach($exams as $exam):?>
	 				<option value="<?php echo $exam->ID?>"><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
				
				<?php _e('achieving the following grade:', 'watuprocmon')?>
				<span id="wbbGradeSelector">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watuprocmon');?></option>
					   <?php foreach($exams[0]->grades as $grade):?>
					   	<option value="<?php echo $grade->ID?>"><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>				
				 			
	 			<?php printf(__('subscribe them to mailing list (enter <a href="%s" target="_blank">Campaign Monitor list ID</a>)','watuprocmon'), 'https://www.campaignmonitor.com/api/getting-started/#listid');?> 
	 			<input type="text" name="list_id">
	 			<input type="submit" name="add" value="<?php _e('Add Rule', 'watuprocmon')?>">
	 	</div>
	 	<?php wp_nonce_field('watuprocmon_rule');?>
	 </form> 
	 
	 <h2><?php _e('Manage Existing Rules', 'watuprocmon')?></h2>
	 <?php if(count($relations)):?>
	 	<?php foreach($relations as $relation):?>
	 	<form method="post">
	 	<input type="hidden" name="id" value="<?php echo $relation->id?>">
	 	<input type="hidden" name="del" value="0">
	 	<div class="wrap">
	 			<?php _e('When user completes', 'watuprocmon')?> <select name="exam_id" onchange="wcChangeQuiz(this.value, 'wbbGradeSelector<?php echo $relation->id?>');">
	 			<option value=""><?php _e('- Select quiz -', 'watuprocmon');?></option>
	 			<?php foreach($exams as $exam):
	 				$selected = ($exam->ID == $relation->exam_id) ? " selected" : "";?>
	 				<option value="<?php echo $exam->ID?>"<?php echo $selected?>><?php echo stripslashes($exam->name)?></option>
	 			<?php endforeach;?>
	 			</select> 
	 			
				<?php _e('achieving the following grade:', 'watuprocmon')?>
				<span id="wbbGradeSelector<?php echo $relation->id?>">
					<select name="grade_id">
					   <option value="0"><?php _e('- Any grade -', 'watuprocmon');?></option>
					   <?php foreach($relation->grades as $grade):
					   	$selected = ($grade->ID == $relation->grade_id) ? " selected" : "";?>
					   	<option value="<?php echo $grade->ID?>"<?php echo $selected?>><?php echo stripslashes($grade->gtitle);?></option>
					   <?php endforeach;?>
					</select>
				</span>			
					 			
	 			<?php _e('subscribe them to mailing list','watuprocmon')?> 
	 			<?php printf(__('subscribe them to mailing list (enter <a href="%s" target="_blank">Campaign Monitor list ID</a>)','watuprocmon'), 'https://www.campaignmonitor.com/api/getting-started/#listid');?> 
	 			<input type="text" name="list_id" value="<?php echo $relation->list_id?>">
	 			<input type="submit" name="save" value="<?php _e('Save Rule', 'watuprocmon')?>">
	 			<input type="button" value="<?php _e('Delete Rule', 'watuprocmon')?>" onclick="WCConfirmDelete(this.form);">
	 	</div>
	 	<?php wp_nonce_field('watuprocmon_rule');?>
	 </form> 
	 	<?php endforeach;?>
	 <?php else:?>
	 <p><?php _e('You have not created any rules yet.', 'watuprocmon');?></p>	
	 <?php endif;?>
</div>

<script type="text/javascript" >
function WCConfirmDelete(frm) {
		if(confirm("<?php _e('Are you sure?', 'wbbridge')?>")) {
			frm.del.value=1;
			frm.submit();
		}
}

function wcChangeQuiz(quizID, selectorID) {
	// array containing all grades by exams
	var grades = {<?php foreach($exams as $exam): echo $exam->ID.' : {';
			foreach($exam->grades as $grade):
				echo $grade->ID .' : "'.$grade->gtitle.'",';
			endforeach;
		echo '},';
	endforeach;?>};
	
	// construct the new HTML
	var newHTML = '<select name="grade_id">';
	newHTML += "<option value='0'><?php _e('- Any grade -', 'watuprocmon');?></option>";
	jQuery.each(grades, function(i, obj){
		if(i == quizID) {
			jQuery.each(obj, function(j, grade) {
				newHTML += "<option value=" + j + ">" + grade + "</option>\n";
			}); // end each grade
		}
	});
	newHTML += '</select>'; 
	
	jQuery('#'+selectorID).html(newHTML);
}
</script>